﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TinyEngine.Core.Scene;

namespace TinyEngine.Core.Components
{
    public abstract class TinyComponentBase : ITinyComponent
    {
        public IEntity Owner { get; private set; }

        public TinyComponentBase(IEntity owner)
        {
            this.Owner = owner;
        }

        public abstract void Update(float elapsed);

        public abstract void Register();

    }

    public abstract class TinySceneComponentBase : ITinySceneComponent
    {
        public TinyScene Owner { get; private set; }

        public TinySceneComponentBase(TinyScene owner)
        {
            this.Owner = owner;
        }

        public abstract void Update(float elapsed);

        public abstract void Register();
    }
}
