﻿
using System;
namespace TinyEngine.Core.Asset
{
    public class TinyAsset<T>
    {
        public event Action<object> Updated;

        public string Name { get; set; }
        public void FireUpdated()
        {
            if (Updated != null)
                Updated(this);
        }
        public string Location { get; set; }
        
        public bool Loaded { get; set; }

        public T Asset { get; protected set; }

        public TinyAsset(string name, string location)
        {
            this.Name = name;
            this.Location = location;
        }
    }
}
