﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using TinyEngine.Core.Camera;

namespace TinyEngine.Core.Parsers
{
    public class Basic2DCameraParser : IEntityParser
    {
        public System.Xml.Linq.XElement ToXmlElement(IEntity obj)
        {
            var root = new System.Xml.Linq.XElement(obj.GetType().Name);
            root.SetAttributeValue("Name", obj.Name);
            if (obj.Position != Vector3.Zero)
            {
                root.SetAttributeValue("Position", ParserHelper.VectorToString(obj.Position));
            }
            var cam = obj as ICamera;
            root.SetAttributeValue("ViewPortSize", ParserHelper.PointToString(cam.ViewPortSize));
            return root;
        }

        public IEntity FromXmlElement(System.Xml.Linq.XElement element)
        {
            var nl = new Basic2DCamera();
            nl.Name = element.Attribute("Name").Value;
            nl.Position = ParserHelper.TryParseVector3("Position", element);
            nl.ViewPortSize = ParserHelper.TryParsePoint("ViewPortSize", element);
            return nl;
        }
    }

}
